
From: Pierre Ossman <drzeus-list@drzeus.cx>

Try SD cards before MMC.

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 drivers/mmc/mmc.c |   14 +++++++-------
 1 files changed, 7 insertions(+), 7 deletions(-)

diff -puN drivers/mmc/mmc.c~sd-read-only-switch-mmc-sd-init-order-fix drivers/mmc/mmc.c
--- devel/drivers/mmc/mmc.c~sd-read-only-switch-mmc-sd-init-order-fix	2005-08-08 22:09:50.000000000 -0700
+++ devel-akpm/drivers/mmc/mmc.c	2005-08-08 22:09:50.000000000 -0700
@@ -830,23 +830,23 @@ static void mmc_setup(struct mmc_host *h
 		int err;
 		u32 ocr;
 
-		host->mode = MMC_MODE_MMC;
+		host->mode = MMC_MODE_SD;
 
 		mmc_power_up(host);
 		mmc_idle_cards(host);
 
-		err = mmc_send_op_cond(host, 0, &ocr);
+		err = mmc_send_app_op_cond(host, 0, &ocr);
 
 		/*
-		 * If we fail to detect any cards then try
-		 * searching for SD cards.
+		 * If we fail to detect any SD cards then try
+		 * searching for MMC cards.
 		 */
 		if (err != MMC_ERR_NONE) {
-			err = mmc_send_app_op_cond(host, 0, &ocr);
+			host->mode = MMC_MODE_MMC;
+
+			err = mmc_send_op_cond(host, 0, &ocr);
 			if (err != MMC_ERR_NONE)
 				return;
-
-			host->mode = MMC_MODE_SD;
 		}
 
 		host->ocr = mmc_select_voltage(host, ocr);
_
